<?php

namespace EventPortal\Tests\Feature\Admin\Event\Approval;

use EventPortal\Domain\Event\Models\Event;
use EventPortal\Tests\Support\Traits\SeedRolesAndPermissions;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Spatie\Snapshots\MatchesSnapshots;

class FormControllerTest extends TestCase
{
    use RefreshDatabase, SeedRolesAndPermissions, MatchesSnapshots;

    /** @test **/
    public function event_approval_form_displays_showing_event_data()
    {
        $event = factory(Event::class)->state('snapshot')->create();

        $this->assertMatchesJsonSnapshot(
            $this
                ->actingAsSuperAdmin()
                ->get(route('admin.event.approval.index', $event->id))
                ->props()
        );
    }
}
