<?php

namespace EventPortal\Tests\Support\Factories;

use EventPortal\Domain\Permission\Models\Group;
use EventPortal\Domain\Permission\Models\Permission;
use EventPortal\Domain\Permission\Models\Role;
use Illuminate\Support\Collection;
use Illuminate\Support\Str;

class PermissionFactory
{
    public static function makeWithRoleAndGroup(int $amount = 5): Collection
    {
        $roleName = "Role with {$amount}";
        $groupName = "Group with {$amount}";
        $role = factory(Role::class)->create(['label' => $roleName, 'name' => Str::slug($roleName)]);
        $group = factory(Group::class)->create(['label' => $groupName, 'name' => Str::slug($groupName)]);
        return factory(Permission::class, $amount)
            ->state('default')
            ->create([
                'group_id' => $group->id,
            ])
            ->each(static function (Permission $permission) use ($role): void {
                $role->givePermissionTo($permission->name);
            });
    }
}
