<?php

namespace EventPortal\Tests\Unit\Approval\Models;

use EventPortal\Domain\Approval\Models\Approval as ApprovalModel;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\RefreshDatabase;

class ApprovalTest extends TestCase
{
    use RefreshDatabase;

    /** @test */
    public function event_approval_is_audited_when_updated(): void
    {
        config(['audit.console' => true]); // This needs to be before create, or no update audit is created

        $approval = factory(ApprovalModel::class)->state('awaiting-approval')->create();

        $approval->update(['status' => 'declined']);

        $this->assertCount(2, $approval->fresh()->audits); // Created and updated

        $updatedAudit = $approval->fresh()->audits->last();

        $this->assertArraySubset(['status' => 'awaiting-approval'], $updatedAudit->old_values);

        $this->assertArraySubset(['status' => 'declined'], $updatedAudit->new_values);
    }
}
